/* $Id: actionviewer.h 2784 2013-01-10 00:10:54Z ryan $ */

/*
	Skyscraper 1.8 Alpha - Action Viewer
	Copyright (C)2003-2013 Ryan Thoryk
	http://www.skyscrapersim.com
	http://sourceforge.net/projects/skyscraper
	Contact - ryan@tliquest.net

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef ACTIONVIEWER_H
#define ACTIONVIEWER_H

//(*Headers(ActionViewer)
#include <wx/dialog.h>
#include <wx/sizer.h>
#include <wx/button.h>
#include <wx/stattext.h>
#include <wx/textctrl.h>
#include <wx/listbox.h>
//*)

class ActionViewer: public wxDialog
{
	public:

		ActionViewer(wxWindow* parent,wxWindowID id=wxID_ANY,const wxPoint& pos=wxDefaultPosition,const wxSize& size=wxDefaultSize);
		virtual ~ActionViewer();

		//(*Declarations(ActionViewer)
		wxTextCtrl* tType;
		wxTextCtrl* tParameters;
		wxStaticText* StaticText1;
		wxStaticText* StaticText3;
		wxListBox* ActionList;
		wxTextCtrl* tCommand;
		wxTextCtrl* tName;
		wxStaticText* StaticText4;
		wxButton* bRun;
		wxStaticText* StaticText5;
		wxStaticText* StaticText2;
		wxButton* bOK;
		wxTextCtrl* tParentName;
		//*)

	protected:

		//(*Identifiers(ActionViewer)
		static const long ID_ActionList;
		static const long ID_bRun;
		static const long ID_bOK;
		static const long ID_STATICTEXT1;
		static const long ID_tName;
		static const long ID_STATICTEXT2;
		static const long ID_tParentName;
		static const long ID_STATICTEXT3;
		static const long ID_tType;
		static const long ID_STATICTEXT4;
		static const long ID_tCommand;
		static const long ID_STATICTEXT5;
		static const long ID_tParameters;
		//*)

	private:

		//(*Handlers(ActionViewer)
		void On_bRun_Click(wxCommandEvent& event);
		void On_bOK_Click(wxCommandEvent& event);
		void On_ActionList_Select(wxCommandEvent& event);
		//*)

		DECLARE_EVENT_TABLE()
};

#endif
